# Zielfunktion:
f = function(x) c(sqrt(abs(x)), x * cos(x))

# Fuer die beiden nachfolgenden Funktionen wird ein data frame benoetigt, der 
# fuenf Spalten enthaelt:
# - x: x-Werte
# - fx: Wert der ersten Komponente von f(x, y)
# - fy: Wert der zweiten Komponente von f(x, y)
# - col: factor mit Farben fuer dominierte/nicht dominierte bzw. effiziente/nicht
#        effiziente Punkte

# Funktion zum plotten der Paretofront:
plot_paretofront = function(data, xlim = c(0, 4), ylim = c(-10, 10), 
                            xlab = "sqrt(abs(x))", ylab = "x * cos(x)") {
  ggplot(data, aes(x = fx, y = fy, col = col, shape = col)) + geom_point() +
    xlab(xlab) + ylab(ylab) +  ggtitle("Paretofront") +
    coord_cartesian(xlim = xlim, ylim = ylim) +
    scale_color_manual("", values = c("blue", "red"),
                       labels = c("effizient", "nicht effizient"), drop = FALSE)  + 
    theme(legend.position = "bottom") +
    scale_shape_manual("", values = c(3, 1),
                       labels = c("effizient", "nicht effizient"), drop = FALSE)
}

# Funktion zum plotten der Paretomenge:
plot_paretoset = function(data, xlim = c(-10, 10)) {
  ggplot(data, aes(x = x, y = 0, col = col, shape = col)) + geom_point() +
    xlab("x") + ylab("") +  ggtitle("Paretoset") +
    coord_cartesian(xlim = xlim) + 
    scale_color_manual("", values = c("blue", "red"), 
                       labels = c("Pareto-optimal", "nicht Pareto-optimal"), 
                       drop = FALSE) + 
    theme(legend.position = "bottom") +
    scale_shape_manual("", values = c(3, 1),
                       labels = c("Pareto-optimal", "nicht Pareto-optimal"), drop = FALSE)
}
